"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMockMiddleware = void 0;
/* eslint-disable no-console */
const fs_1 = __importDefault(require("fs"));
const router_1 = __importDefault(require("./router"));
const operations_1 = require("./operations");
const middleware_1 = require("./middleware");
const createMockMiddleware = ({ 
/**
 * @deprecated
 */
file, spec, locale = 'en', options = {}, jsfCallback, }) => {
    if (file) {
        console.warn('The file option is deprecated. Please, use spec option instead.');
    }
    const docSpec = !spec ? file : spec;
    if (typeof docSpec === 'string' && !fs_1.default.existsSync(docSpec)) {
        throw new Error(`OpenAPI spec not found at location: ${docSpec}`);
    }
    else if (docSpec === undefined) {
        throw new Error(`OpenAPI spec not provided`);
    }
    const router = (0, router_1.default)();
    const operations = (0, operations_1.createOperations)({ spec: docSpec, locale, options, callback: jsfCallback });
    router.use('/{0,}', (req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
        res.locals.operation = yield operations.match(req);
        next();
    }));
    router.use(middleware_1.isAuthenticated, middleware_1.validateHeaders, middleware_1.validatePath, middleware_1.validateQuery, middleware_1.validateBody);
    router.use((req, res, next) => {
        return res.locals.operation ? res.locals.operation.generateResponse(req, res) : next();
    });
    router.use((req, res) => {
        res.status(404).send({ message: 'Not found' });
    });
    router.use((err, req, res) => {
        res.status(500).send({ message: 'Something broke!' });
    });
    return router;
};
exports.createMockMiddleware = createMockMiddleware;
//# sourceMappingURL=index.js.map