import { OpenAPIV3 } from 'openapi-types';
import { Request } from 'express';
import { JSFOptions, JSF, JSFCallback } from '../utils';
import { Operation } from './operation';
export declare class Operations {
    operations: Operation[] | null;
    spec: string | OpenAPIV3.Document;
    locale: string;
    generator: JSF;
    constructor({ spec, locale, options, callback, }: {
        spec: string | OpenAPIV3.Document;
        locale: string;
        options: Partial<JSFOptions>;
        callback?: JSFCallback;
    });
    reset(): void;
    watch(): void;
    compile(): Promise<void>;
    compileFromPath(pathName: string, pathOperations: OpenAPIV3.PathItemObject, securitySchemes?: {
        [key: string]: OpenAPIV3.SecuritySchemeObject;
    }): Operation[];
    match(req: Request): Promise<Operation | null>;
}
export declare const createOperations: ({ spec, locale, options, callback, }: {
    spec: string | OpenAPIV3.Document;
    locale: string;
    options: Partial<JSFOptions>;
    callback?: JSFCallback | undefined;
}) => Operations;
